var isCollapsed = true;
var skypeNumber = '';
var fixedNumber = false;
var callTo = '';

function saveSetting() {
	var showHelp = document.getElementById('dialinghelp').checked;
	if (window.widget) {
		if(showHelp) {
			widget.setPreferenceForKey(true, createkey("collapsed"));
		} else {
			widget.setPreferenceForKey(null, createkey("collapsed"));
        }
	}
    
    isCollapsed = !isCollapsed;
    totalWidgetHeight = calculateBackgroundHeight();
    if(!isCollapsed && window.widget) {
        window.resizeTo(350, totalWidgetHeight);
    }
}

function skypeCall() {
    var skypeNumber = document.getElementById('skypeoutnumber').value;
    if(skypeNumber) {
        var character = skypeNumber.charAt(0);
        if(isNumeric(character)) {
            var callToNumber = "+" + skypeNumber;
        }
    } else {
        var callTo = document.getElementById('number').value;
        if(callTo != "Type Skype Name or phone number..." && callTo != "") {
            var callToNumber = callTo;
        }
    }
    if(widget && typeof(callToNumber) != "undefined") {
        widget.openURL('callto://' + callToNumber);
    }
    return false;
}

function showBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");
    
    if (window.widget)
        widget.prepareForTransition("ToBack");
    
    front.style.display="none";
    back.style.display="block";
    
    if (window.widget)
       setTimeout ('widget.performTransition();', 0);  
}

function hideBack() {
    var front = document.getElementById("front");
    var back = document.getElementById("back");

    if (window.widget)
        widget.prepareForTransition("ToFront");

    back.style.display="none";
    front.style.display="block";
    
    if (window.widget)
        setTimeout ('widget.performTransition();', 0);
}

function enterflip(event) {
    document.getElementById('fliprollie').style.display = 'block';
}

function exitflip(event) {
    document.getElementById('fliprollie').style.display = 'none';
}

var flipShown = false;

var animation = {duration:0, starttime:0, to:0.5, now:0.0, from:0.0, firstElement:null, timer:null};

function mousemove(event) {
    if (!flipShown) {
        if (animation.timer != null) {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
		
        var starttime = (new Date).getTime() - 13;
		
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 1.0;
        animate();
        flipShown = true;
    }
}

function mouseexit(event) {
    if (flipShown) {
        if (animation.timer != null) {
            clearInterval (animation.timer);
            animation.timer  = null;
        }
		
        var starttime = (new Date).getTime() - 13;
		
        animation.duration = 500;
        animation.starttime = starttime;
        animation.firstElement = document.getElementById('flip');
        animation.timer = setInterval ("animate();", 13);
        animation.from = animation.now;
        animation.to = 0.0;
        animate();
        flipShown = false;
    }
}

function animate() {
    var T;
    var ease;
    var time = (new Date).getTime();
		
    T = limit_3(time-animation.starttime, 0, animation.duration);
	
    if(T >= animation.duration) {
        clearInterval (animation.timer);
        animation.timer = null;
        animation.now = animation.to;
    } else {
        ease = 0.5 - (0.5 * Math.cos(Math.PI * T / animation.duration));
        animation.now = computeNextFloat (animation.from, animation.to, ease);
    }
	
    animation.firstElement.style.opacity = animation.now;
}

function resizeAnimateDiv() {
	var T;
	var ease;
	var time  = (new Date).getTime();
	var yLoc;
	var frame;
		
	T = limit_3(time-resizeAnimation.startTime, 0, resizeAnimation.duration);
	ease = 0.5 - (0.5 * Math.cos(Math.PI * T / resizeAnimation.duration));

	if(T >= resizeAnimation.duration) {
		yLoc = resizeAnimation.positionTo;
		clearInterval (resizeAnimation.timer);
		resizeAnimation.timer = null;
		
		if (resizeAnimation.onfinished)
			setTimeout ("resizeAnimation.onfinished();", 0);
	} else {
		yLoc = computeNextFloat(resizeAnimation.positionFrom, resizeAnimation.positionTo, ease);
    }
		
	resizeAnimation.positionNow = parseInt(yLoc);
	resizeAnimation.element.style.height = resizeAnimation.positionNow + "px";
} 

function limit_3(a, b, c) {
    return a < b ? b : (a > c ? c : a);
}

function computeNextFloat(from, to, ease) {
    return from + (to - from) * ease;
}

function createkey(key) {
	return widget.identifier + "-" + key;
}

function calculateBackgroundHeight() {
	var height;
	if(isCollapsed)
		height = 46;
	else
		height = 296;

    return height;
} 

function animFinished() {
	if (window.widget) {
		if(isCollapsed) {
			totalWidgetHeight = calculateBackgroundHeight();
			window.resizeTo(350, totalWidgetHeight);
		}
	}
}

var resizeAnimation = {startTime:0, duration:250, positionFrom:0, positionTo:0, positionNow:0, frameFrom:0, frameTo:0, frameNow:0, timer:null, element:null, image:null, background:null, onfinished:null};

function toggleView(event) {
    var helperDiv = document.getElementById("helper");
    var timeNow = (new Date).getTime();
    var multiplier = (event.shiftKey ? 10 : 1);
    var startingSize = parseInt(helperDiv.clientHeight,10);

    resizeAnimation.element = helperDiv;
    if(resizeAnimation.timer != null) {
        clearInterval(resizeAnimation.timer);
        resizeAnimation.timer = null;
        resizeAnimation.duration -= (timeNow - resizeAnimation.startTime);
        resizeAnimation.positionFrom = resizeAnimation.positionNow;
    } else {
        resizeAnimation.duration = 250 * multiplier;
        resizeAnimation.positionFrom = startingSize;
    }
    
    isCollapsed = !isCollapsed;
    var resizeTo = isCollapsed ? 0 : 260;
    totalWidgetHeight = calculateBackgroundHeight();
    
    if(!isCollapsed && window.widget)
        window.resizeTo(350, totalWidgetHeight);

    resizeAnimation.positionTo = parseInt(resizeTo);
    resizeAnimation.startTime = timeNow - 13;
    resizeAnimation.onfinished = animFinished;
    
    resizeAnimation.element.style.height = startingSize;
    resizeAnimation.timer = setInterval("resizeAnimateDiv();", 13);
    resizeAnimateDiv();
}

function callHover(state) {
    callOverImage = new Image();
    callOverImage.src = "Images/call_button_hover.png";
    callOutImage = new Image();
    callOutImage.src = "Images/call_button.png";
    
    var callButton = document.getElementById("CallButton");
    
    if(state == "over") {
        callButton.src = callOverImage.src;
    } else {
        callButton.src = callOutImage.src;
    }
}